<?xml version="1.0"?>

<st-source>
<!-- Changes in change set Monty -->
<time-stamp>From VisualWorks®, 7.3.1 of April 20, 2005 on March 28, 2008 at 12:24:38 pm</time-stamp>


<class>
<name>PvCmeAbstractTreeBuilder</name>
<environment>PROVISO</environment>
<super>PROVISO.PvCmeAbstractTreeManipulator</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>newRawBucketsCount newRABucketsCount </inst-vars>
<class-inst-vars></class-inst-vars>
<imports>
			PROVISO.PvFormulas.*
			</imports>
<category>PV CME-Core</category>
<attributes>
<package>PV-CME-Core</package>
</attributes>
</class>

<class>
<name>PvCalendarManager</name>
<environment>PROVISO</environment>
<super>PROVISO.PvDomainObjectManager</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>calendarsByGroupId timezonesByGroupId timezones defaultForInactiveBuckets </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-DM-Calendars</category>
<attributes>
<package>PV-DM-Managers</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.PvBaseSubelementManager</class-id> <category>performance</category>

<body package="PV-DM-Managers" selector="groupDensityForActiveResources">groupDensityForActiveResources

	| sum |

	((itemsById size) = 0)
		ifTrue: [ ^-1 ]. "Degenerate case...it's worth identifying in the log file"

	sum := 0.

	self itemsDo: [:se | 
		se isActive 
			ifTrue: [sum := sum + (se parents size)]].

	^sum / (itemsById size) asFloat.</body>

<body package="PV-DM-Managers" selector="groupDensityForResourcesSatisfying:">groupDensityForResourcesSatisfying: aBlock 
	
	| sum count |
	itemsById ifNil: [^-1].
	"Degenerate case...it's worth identifying in the log file"
	sum := 0.
	count := 0.
	self itemsDo: 
		[:se | 
		(aBlock value: se) 
			ifTrue: 
				[count := count + 1.
				se parentsDo: 
					[:eachGroup | 
					eachGroup hasTimezoneAndCalendar 
						ifTrue: [sum := sum + 1]]]].
	^count = 0 
		ifTrue: [-1]
		ifFalse: [sum / count asFloat]</body>
</methods>


<methods>
<class-id>PROVISO.PvCmeAbstractTreeBuilder</class-id> <category>accessing</category>

<body package="PV-CME-Core" selector="newRABucketsCount">newRABucketsCount
	^newRABucketsCount ifNil: [newRABucketsCount := 0]</body>

<body package="PV-CME-Core" selector="newRABucketsCount:">newRABucketsCount: anObject
	newRABucketsCount := anObject</body>

<body package="PV-CME-Core" selector="newRawBucketsCount">newRawBucketsCount
	^newRawBucketsCount ifNil: [newRawBucketsCount := 0]</body>

<body package="PV-CME-Core" selector="newRawBucketsCount:">newRawBucketsCount: anObject
	newRawBucketsCount := anObject</body>
</methods>


<methods>
<class-id>PROVISO.PvCmeAbstractTreeBuilder</class-id> <category>private</category>

<body package="PV-CME-Core" selector="privateAddRaBucketAtMid:gid:rid:calendar:timezone:threshold:quantile:alreadyAdded:">privateAddRaBucketAtMid: metricId
	gid: groupId
	rid: resourceId
	calendar: calendar
	timezone: timezone
	threshold: threshold
	quantile: aNumber
	alreadyAdded: addedBuckets
	
	| bucket |
	bucket := 
		PvRaBucket 
			fromMid: metricId
			gid: groupId
			rid: resourceId
			timezone: timezone
			calendar: calendar
			threshold: threshold
			quantile: aNumber
			minMaxDate: self cmeEngine channelStartDate.
	addedBuckets notNil 
		ifTrue: [addedBuckets add: bucket].
	self raData 
		atMid: metricId
		gid: groupId
		rid: resourceId
		put: bucket.
	self newRABucketsCount: self newRABucketsCount + 1.
	^bucket</body>
</methods>


<methods>
<class-id>PROVISO.PvCmeStateImporter</class-id> <category>private</category>

<body package="PV-CME-Core" selector="createInactiveGaBucketFor:timezone:">createInactiveGaBucketFor: gaRecord timezone: timezone
	"An inactive bucket starts out completely expired. As we find period records, we un-expire
	each period selectively."

	| bucket |
	bucket := self
		addGaBucketAtMid: gaRecord metricId
		gid: gaRecord groupId
		calendar: self pvModel calendarManager defaultForInactiveBuckets
		timezone: timezone.

	bucket
		clearActive;
		expireAll.

	^bucket</body>

<body package="PV-CME-Core" selector="createInactiveRaBucketFor:timezone:">createInactiveRaBucketFor: raRecord timezone: timezone 
	"An inactive bucket starts out completely expired. As we find period records, we un-expire
	each period selectively."
	
	| threshold |
	threshold := 
		self pvModel thresholdManager 
			thresholdForMetricId: raRecord metricId
			groupId: raRecord groupId
			resourceId: raRecord resourceId.
	^(self 
		privateAddRaBucketAtMid: raRecord metricId
		gid: raRecord groupId
		rid: raRecord resourceId
		calendar: self pvModel calendarManager defaultForInactiveBuckets
		timezone: timezone
		threshold: threshold
		quantile: (raRecord hasPercentileData ifTrue: [raRecord quantileAsPercent] ifFalse: [0])
		alreadyAdded: nil)
		clearActive;
		expireAll;
		yourself</body>

<body package="PV-CME-Core" selector="importAggregateDataFile:timezone:">importAggregateDataFile: dataFile timezone: timezone 
	
	| selectors stream eachRecord rec args |
	selectors := self selectorsForDataType: dataFile dataType.
	stream := dataFile readStream.
	args := Array new: 4.
	rec := stream newBlankRecord.
	[[stream atEnd] 
		whileFalse: 
			[eachRecord := stream nextRecordInto: rec.
			eachRecord notNil 
				ifTrue: 
					[(self 
						isValidRaRecord: eachRecord
						timezone: timezone) 
							ifTrue: 
								[args
									at: 1 put: eachRecord;
									at: 2 put: dataFile;
									at: 3 put: timezone;
									at: 4 put: selectors value.
								self 
									perform: selectors key
									withArguments: args]]]] 
										ensure: [stream close]</body>
</methods>


<methods>
<class-id>PROVISO.PvCalendarManager</class-id> <category>accessing</category>

<body package="PV-DM-Managers" selector="defaultForInactiveBuckets">defaultForInactiveBuckets
	^defaultForInactiveBuckets</body>

<body package="PV-DM-Managers" selector="defaultForInactiveBuckets:">defaultForInactiveBuckets: anObject
	defaultForInactiveBuckets := anObject</body>
</methods>


<methods>
<class-id>PROVISO.PvCalendarManager</class-id> <category>initializing</category>

<body package="PV-DM-Managers" selector="initialize">initialize

	super initialize.
	calendarsByGroupId := PvLargeDictionary newSizedFor: self class expectedItemsCount.
	timezonesByGroupId := PvLargeDictionary newSizedFor: self class expectedItemsCount.
	timezones := Dictionary new.
	self defaultForInactiveBuckets: self itemClass new.</body>
</methods>


<methods>
<class-id>PROVISO.PvCmeEngine</class-id> <category>utility/debugging</category>

<body package="PV-CME-Core" selector="debugSetupChannel:collector:currentHour:dbEnvironment:dbUsername:dbPassword:resync:">debugSetupChannel: aChannelNumber 
	collector: collectorNumber
	currentHour: currentHourString
	dbEnvironment: dbEnvironment
	dbUsername: dbUsername
	dbPassword: dbPassword
	resync: numberOfTimesToResync
		"self new
			debugSetupChannel: 1 
			collector: 1
			currentHour: '2008.02.27-00.00.00'
			dbEnvironment: 'PMGDEVAIX2'
			dbUsername:  'CISCODTV'
			dbPassword: 'DTV'
			resync: 14*24+9
	"
	
	| cme currentHourTimestamp app |
	currentHourTimestamp := PvTimestamp readFrom: currentHourString readStream.
	self currentApplication notNil
		ifTrue: [self currentApplication stopImmediate].
	app := PvUnitTestApplication new
		facilityName: 'CME.', aChannelNumber printString, '.', collectorNumber printString;
		start;
		useTestCaseFileLogger;
		yourself.
	app logger logToTranscript: true.
	ObjectMemory installPvMemoryPolicy.
	cme := self class new.
	cme dbSession
		disconnect;
		setUsername: dbUsername  
			password: dbPassword 
			environment: dbEnvironment.
	cme pvModel: self getPvModel.
	cme pvModel 
		initializeForCme;
		loadCollectorsByChannel.
	cme
		inspect;
		testMode: true;
		postInitialize;
		raData: (PvMidGidRidBTree on: cme pvModel);
		stats: PvCmeStats new;
		currentHour: currentHourTimestamp;
		configuration: (	PvConfiguration new
			at: 'ROOT_DIRECTORY' put: 'DCTEST';
			at: 'CHANNEL' put: aChannelNumber printString;
			at: 'FC_FSLL' put: '1000000';
			at: 'FC_QUOTA' put: '100000000';
			at: 'POLL_INTERVAL' put: '1' ;
			at: 'COLLECTOR' put: collectorNumber printString;
			at: 'INPUT_DIRECTORIES' put: 'DCTEST/FTE.1.3/output';
			at: 'GA_ROLLUP_RELATIONS' put: 'qcf5620_local,qcf5620_endPoint1';
			yourself);
"		inputDirectory: 'DCTEST/FTE.1.1/output' asFilename;"
		channel: aChannelNumber.
	cme dbSession
		doSelect: false;
		doNonSelect: false.
	cme hookPreRun.
	cme dbSession doSelect: true.
	cme
		doPreHourlyProcessing;
"halt;"
		debugResyncCmeEngineFor: numberOfTimesToResync.
self halt.</body>
</methods>

<methods>
<class-id>PROVISO.PvCmeEngine</class-id> <category>processing (pre-hourly)</category>

<body package="PV-CME-Core" selector="resetGaBucketsForStartOfPeriod">resetGaBucketsForStartOfPeriod
	"Cache the dayStart, weekStart, and monthStart seconds in each RA and GA bucket.
	The start seconds is the start of the current hour, thus it is different for each timezone."
	
	self system 
		logDebugThree: #RESET_GA
		messageId: nil
		text: 'Resetting GA buckets for new period'.
	self gaBucketsDo: 
		[:eachBucket | 
		| startOfPeriodContainer |
		startOfPeriodContainer := 
			self 
				startOfPeriodContainerForTimezone: eachBucket timezone
				hour: self currentHourAsNumber.
		eachBucket resetForStartOfPeriod: startOfPeriodContainer]</body>

<body package="PV-CME-Core" selector="resetRaBucketsForStartOfPeriod">resetRaBucketsForStartOfPeriod
	"Cache the dayStart, weekStart, and monthStart seconds in each RA and GA bucket.
	The start seconds is the start of the current hour, thus it is different for each timezone."
	
	self system 
		logDebugThree: #RESET_RA
		messageId: nil
		text: 'Resetting RA buckets for new period'.
	self raBucketsDo: 
		[:eachBucket | 
		| startOfPeriodContainer |
		startOfPeriodContainer := 
			self 
				startOfPeriodContainerForTimezone: eachBucket timezone
				hour: self currentHourAsNumber.
		eachBucket resetForStartOfPeriod: startOfPeriodContainer]</body>
</methods>


<methods>
<class-id>PROVISO.PvMultiLevelBTree</class-id> <category>accessing</category>

<body package="PV-Collections" selector="trueSize">trueSize
	
	|count|
	count := 0.
	self do: [:each | count := count + 1].
	^count</body>
</methods>


<methods>
<class-id>PROVISO.PvCmeNormalTreeBuilder</class-id> <category>building buckets</category>

<body package="PV-CME-Core" selector="buildExtendedResourceCountBuckets">buildExtendedResourceCountBuckets
	"Now add the extended resource group buckets..."
	
	| bucket resourceCount myCollectorNumber|
	self system logDebugThree: #BULD_EXT_RC text: 'Building Extended Resource Counts'.
	myCollectorNumber := self cmeEngine collectorNumber.
	PvModel current subelementManager allGroups do: 
		[:eachGroup | 
		| timezone calendar |
		calendar := eachGroup calendar.
		timezone := eachGroup timezone.
		calendar notNil &amp; timezone notNil 
			ifTrue: 
				[bucket := 
					self 
						addGaBucketAtMid: 0
						gid: eachGroup id
						calendar: calendar
						timezone: timezone.
				resourceCount := 0.
				eachGroup allLeafNodesDo: [:eachSe |
					eachSe collectorNumber = myCollectorNumber
						ifTrue: [resourceCount := resourceCount + 1]].
				bucket dayRecord count: resourceCount.
				bucket weekRecord count: resourceCount.
				bucket monthRecord count: resourceCount]]</body>

<body package="PV-CME-Core" selector="buildFor:">buildFor: actualResources 
	
	| buildStats buildTimesPerRequest time inverseRelationMap |
	newRawBucketsCount := newRABucketsCount := 0.
	inverseRelationMap := self buildInverseRelationMap.
	buildTimesPerRequest := IdentityDictionary new: 512.
	actualResources do: 
		[:eachResource | 
		eachResource isDeleted 
			ifFalse: 
				[eachResource metricRequestsDo: 
					[:eachRequest | 
					time := 
						(eachRequest hasFormula and: [self doesChannelContainResource: eachResource]) 
							ifTrue: 
								[Time microsecondsToRun: 
									[self 
										buildAllForRequest: eachRequest
										resource: eachResource
										inverseRelationMap: inverseRelationMap]]
							ifFalse: [0].
					buildStats := 
						buildTimesPerRequest 
							at: eachRequest
							ifAbsentPut: [0 -&gt; 0].
					buildStats key: buildStats key + 1.
					buildStats value: buildStats value + time]]].
	self buildGaBuckets.
	buildTimesPerRequest keysAndValuesDo: 
		[:eachRequest :eachAssoc | 
		self 
			logBuildTreeFor: eachRequest
			resources: eachAssoc key
			in: eachAssoc value // 1000].
	self system logDebugOne: #BUILD_NEW_BUCKETS text: 'Created ', newRawBucketsCount asString, ' new RAW buckets, ', newRABucketsCount asString, ' new RA buckets'.</body>

<body package="PV-CME-Core" selector="buildGaBuckets">buildGaBuckets
	
	self cmeEngine doGa 
		ifFalse: [^self].
	"First add the group buckets for groups we are collecting against."
	self system logDebugThree: #BULD_GA text: 'Building GA buckets'.
	self cmeEngine doRaLevelGroups: 
		[:eachMetricId :eachGroupId | 
		self 
			buildGaBucketsForMid: eachMetricId
			gid: eachGroupId].
	self buildExtendedResourceCountBuckets</body>
</methods>


<methods>
<class-id>PROVISO.PvRequest</class-id> <category>helpers</category>

<body package="PV-DM-Support" selector="basicCreateRawBucketIn:resource:">basicCreateRawBucketIn: aTreeBuilder resource: aResource 
	| bucket |
	bucket := aTreeBuilder rawData 
				atMid: self formulaIndex
				rid: aResource id
				ifAbsent: [nil].
	bucket isNil
		ifTrue: 
			[bucket := aTreeBuilder rawData 
				atMid: self formulaIndex
				rid: aResource id
				put: (aTreeBuilder createRawBucketForRequest: self resource: aResource).
	aTreeBuilder newRawBucketsCount: aTreeBuilder newRawBucketsCount + 1.
].
	^bucket</body>
</methods>


<methods>
<class-id>PROVISO.PvCmeTreePruner</class-id> <category>private sweep</category>

<body package="PV-CME-Core" selector="removeUnmarkedRaBuckets">removeUnmarkedRaBuckets
	"Do a full sweep on the RA tree and:
		- gc inactive &amp; expired buckets
		- expire active &amp; not marked buckets
		- convert all invalid proxy buckets to real bucket"
	
	| raKeysToGc |
	raKeysToGc := OrderedCollection new: 1000.
	self cmeEngine raBucketsKeysAndValuesDo: 
		[:eachKey :eachBucket | 
		| active |
		active := eachBucket isActive.
		"First case, inactive &amp; expired -&gt; GC the bucket..."
		(active not and: [eachBucket isExpired]) 
			ifTrue: [raKeysToGc add: eachKey copy].
		"Second case, active &amp; not marked -&gt; set it up for expiry..."
		(active and: [eachBucket notMarked]) 
			ifTrue: 
				[eachBucket
					clearActive;
					clearExpired]].
	self system logDebugOne: #RA_CLEANUP_START text: 'About to remove ', raKeysToGc size printString, ' RA bucktes'.
	raKeysToGc do: 
		[:each | 
		self logRemoveRaBucketWithKey: each.
		self removeRaBucket: each].</body>

<body package="PV-CME-Core" selector="removeUnmarkedRawBucketsAndInitializeFormulasWithPropertyBindings">removeUnmarkedRawBucketsAndInitializeFormulasWithPropertyBindings
	"Do a full sweep on the Raw tree and figure out 
	what buckets need to be removed (those that are 
	not marked).  Then remove them."

	| rawKeysToGs |
	rawKeysToGs := OrderedCollection new: 1000.
	self cmeEngine rawBucketsKeysAndValuesDo: 
		[:eachKey :eachBucket | 
		eachBucket canBeDeleted 
			ifTrue: 
				[eachBucket resetBucket.
				rawKeysToGs add: eachKey copy]
			ifFalse: 
				[eachBucket isMarked
					ifTrue:
						[eachBucket formula notNil 
							ifTrue: [eachBucket formula initializePropertyInputState]]
					ifFalse: [eachBucket markForDeleteWhenInactive]]].
	self system logDebugOne: #RAW_CLEANUP_START text: 'About to remove ', rawKeysToGs size printString, ' raw bucktes'.
	rawKeysToGs do: 
		[:each | 
		"self logRemoveRawBucketWithKey: each."
		self removeRawBucket: each]</body>
</methods>


<methods>
<class-id>PROVISO.PvRaBucket</class-id> <category>expired flag</category>

<body package="PV-CME-Core" selector="isSomeExpired">isSomeExpired

	^self isDayExpired | self isWeekExpired | self isMonthExpired</body>
</methods>



</st-source>
